Summary: binkd - FTN mailer over TCP/IP
Name: binkd
Version: 0.91
Release: 4
Source0: binkd091.zip
Source1: ifmail.logrotate
Patch: binkd.cfg.patch
Copyright: GPL
Group: Networking/Utilities
#Requires: ifmail
Buildroot: /tmp/binkd-root

%description
BinkD is a new BSO (Binkley Style Outbound) mailer that works with TCP/IP only.
It's protocol (called BINKP) is already supported by Argus. BinkD is available
with sources and is designed keeping in mind portability between
Windows'95/WinNT/OS2/Unix platforms. It is very simple in setup, extremely
small in size and provides probably the best throughput over TCP/IP links.

%prep
unzip -o $RPM_SOURCE_DIR/binkd091.zip
%setup -D -n binkd091
%patch -p 1
%build
cp mkfls/unix/* .
chmod a+x configure
./configure --prefix=/usr
make

%pre
export PATH=/bin:/usr/bin:$PATH
TMP=`grep ^fnet: /etc/passwd`
if [ "$TMP" = "" ]; then
   while [ -r /etc/.pwd.lock ]; do sleep 5 ; done
   touch /etc/.pwd.lock
   cp /etc/passwd /etc/passwd-
   IF_UID=2200
   while grep "[^:]*:[^:]*:$IF_UID:.*" /etc/passwd > /dev/null
   do IF_UID=`expr $IF_UID + 1` ; done
   IF_GID=`grep ^uucp: /etc/group | cut -d':' -f3`
   if [ "$IF_GID" = "" ]; then
        IF_GID=14
        cp /etc/group /etc/group-
        while grep "[^:]*:[^:]*:$IF_GID:.*" /etc/group > /dev/null
        do IF_GID=`expr $IF_GID + 1` ; done
        echo "uucp::${IF_GID}:uucp,fnet,news,root,mail" >> /etc/group
   else
	cp /etc/group /etc/group-
	TMP=`grep ^uucp: /etc/group`
	MEMBERS=uucp,fnet,news,root,mail
	for i in `echo $TMP | cut -d: -f4 | tr ',' ' '`; do
		if [ "$i" = "uucp" ]; then : ;
        	elif [ "$i" = "fnet" ]; then : ;
        	elif [ "$i" = "news" ]; then : ;
        	elif [ "$i" = "root" ]; then : ;
        	elif [ "$i" = "mail" ]; then : ;
        	else
        		MEMBERS="$MEMBERS,$i"
        	fi
	done
	LINE="`echo $TMP | cut -d: -f1-3`:$MEMBERS"
	cat /etc/group- | sed s/$TMP/$LINE/ > /etc/group
   fi
   echo "fnet:*:${IF_UID}:${IF_GID}:fnet:/usr/lib/ifmail:" >> /etc/passwd
   rm /etc/.pwd.lock
fi

%install
mkdir -p $RPM_BUILD_ROOT/etc/{logrotate.d,ifmail}
mkdir -p $RPM_BUILD_ROOT{/usr/lib/ifmail,/var/log/ifmail}
install -m600 -o fnet -g uucp binkd.cfg $RPM_BUILD_ROOT/etc/ifmail/binkd.cfg
install -m4750 -o fnet -g uucp binkd $RPM_BUILD_ROOT/usr/lib/ifmail/binkd
# install log file
touch nothing
install -m600 -o fnet -g uucp nothing $RPM_BUILD_ROOT/var/log/ifmail/binkd.log
# install logrotate
install -m644 $RPM_SOURCE_DIR/binkd.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/binkd


%clean
rm -rf $RPM_BUILD_ROOT

%post
export PATH=/bin:/usr/bin:$PATH
TMP=`grep ^binkp /etc/services`
if [ "$TMP" = "" ]; then
	echo "# FTN services
binkp		24554/tcp		# the standard BINKP port
" >> /etc/services
	echo "binkp	stream	tcp	nowait	fnet	/usr/lib/ifmail/binkd binkd -i /etc/ifmail/binkd.cfg
" >> /etc/inetd.conf
	if [ -r /var/run/inetd.pid ]; then
		kill -HUP `head -1 /var/run/inetd.pid`
	fi
fi

%preun
# $1 = 0 is remove; $1 = 1 is update
if [ "$1" = "0" ]; then
	if grep ^binkp /etc/inetd.conf >& /dev/null
	then
		grep -v ^binkp /etc/inetd.conf > /tmp/.inetd.$$
		cat /tmp/.inetd.$$ > /etc/inetd.conf
		rm /tmp/.inetd.$$
		if [ -r /var/run/inetd.pid ]; then
			kill -HUP `head -1 /var/run/inetd.pid`
		fi
	fi
fi

%files
%doc !README !README.FIX !SRIF.TXT
%ghost /var/log/ifmail/binkd.log
%config /etc/ifmail/binkd.cfg
%config /etc/logrotate.d/binkd
/usr/lib/ifmail/binkd
